=== rtt/extras/CMakeLists.txt ===
FILE( GLOB CPPS [^.]*.cpp )
FILE( GLOB HPPS [^.]*.hpp )

GLOBAL_ADD_INCLUDE( rtt/extras ${HPPS})
GLOBAL_ADD_SRC( ${CPPS})

ADD_SUBDIRECTORY( dev )
