=== rtt/os/oro_noasm/CMakeLists.txt ===
FILE( GLOB HPPS [^.]*.hpp [^.]*.h [^.]*.inl)

GLOBAL_ADD_INCLUDE( rtt/os/oro_noasm ${HPPS})
