=== debian/changelog ===
rock-master-20.01-rtt (0.20190508-1~xenial) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/orocos-toolchain/rtt.git
  * branch: refs/heads/master
  * commit: baaea5022bc79f94770a962e2e16cc0cb28cde0b
  * tag: 

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Sat, 08 Feb 2020 21:48:34 +0100
