=== debian/control ===
Source: rock-master-20.01-rtt
Section: science
Priority: optional
Maintainer: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Uploaders: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, cmake, libboost-dev, libboost-filesystem-dev, libboost-graph-dev, libboost-iostreams-dev, libboost-program-options-dev, libboost-regex-dev, libboost-system-dev, libboost-thread-dev, libomniorb4-dev, libxml-xpath-perl, omniidl, omniorb-nameserver
Standards-Version: 3.9.2
Homepage: http://www.rock-robotics.org

Package: rock-master-20.01-rtt
Architecture: any
Depends: ${shlibs:Depends}, cmake, omniidl, libomniorb4-dev, omniorb-nameserver, libboost-dev, libboost-graph-dev, libboost-program-options-dev, libboost-regex-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-iostreams-dev, libboost-system-dev, libxml-xpath-perl
Description: Orocos/RTT component framework
 Orocos/RTT component framework
